import Styles from "@/constants/Styles"
import { apiGetDivisionOneFeature } from "@/lib/api"
import { useAuthSession } from "@/providers/AuthProvider"
import { useTheme } from "@/providers/ThemeProvider"
import { AntDesign } from "@expo/vector-icons"
import { router, useLocalSearchParams } from "expo-router"
import { useEffect, useState } from "react"
import { View } from "react-native"
import { useSelector } from "react-redux"
import ButtonMenuHeader from "../buttonMenuHeader"
import DrawerBottom from "../drawerBottom"
import MenuItemRow from "../menuItemRow"

export default function HeaderRightDiscussionList() {
   const { colors } = useTheme()
   const [isVisible, setVisible] = useState(false)
   const [isAdminDivision, setIsAdminDivision] = useState(false);
   const { token, decryptToken } = useAuthSession()
   const { id } = useLocalSearchParams<{ id: string }>();
   const entityUser = useSelector((state: any) => state.user);

   async function handleCheckAdmin() {
      try {
         const hasil = await decryptToken(String(token?.current));
         const response = await apiGetDivisionOneFeature({
            id,
            user: hasil,
            cat: "check-admin",
         });
         setIsAdminDivision(response.data);
      } catch (error) {
         console.error(error);
      }
   }

   useEffect(() => {
      handleCheckAdmin()
   }, [])

   return (
      <>
         {
            (entityUser.role == "user" || entityUser.role == "coadmin") && !isAdminDivision
               ? <></> :
               <ButtonMenuHeader onPress={() => { setVisible(true) }} />
         }
         <DrawerBottom animation="slide" isVisible={isVisible} setVisible={setVisible} title="Menu">
            <View style={Styles.rowItemsCenter}>
               <MenuItemRow
                  icon={<AntDesign name="pluscircleo" color={colors.text} size={25} />}
                  title="Tambah Diskusi"
                  onPress={() => {
                     setVisible(false)
                     router.push('./discussion/create')
                  }}
               />
            </View>
         </DrawerBottom>
      </>
   )
}